program cinewton (input,output) ;
use c_ari ;
use i_ari ;
use ci_ari ;


var x, y : cinterval ; quad : complex ;

operator * (n : integer ; x : cinterval) nimul : cinterval ;
    begin
      nimul.re  := intval (n) *  x.re  ;
      nimul.im  := intval (n) *  x.im  ;
    end ;

procedure write (var t : text; x : interval ; width, aftpoin : integer) ;
  var y : real ;
  begin
    write (t, '[') ;
    y := x.inf ;
    if  abs (y) > 10e20  then
       write (t, y : 23 : 0 : -1)
    else
       write (t, y : width : aftpoin : -1) ;
    write (t,  ',') ;
    y := x.sup ;
    if  abs (y) > 10e20  then
       write (t, y : 23 : 0 : +1)
    else
       write (t, y : width : aftpoin : +1) ;
    write (t, ']');
  end ;

procedure write (var t : text; x : cinterval ; width, aftpoin : integer) ;
  var y : real ;
  begin
    write (t, '(', x.re: width: aftpoin , ',', x.im: width: aftpoin , ')') ;
  end ;

$off
procedure write (var t : text; x : cinterval ; width : integer) ;
  var y : real ;
  begin
    write (t, '(', x.re: width , ',', x.im: width , ')') ;
  end ;
$on

function f (x : cinterval) : cinterval ;
    var y, q : cinterval ;
  begin
$off
    writeln ('    start f') ;
    writeln (' x =    ',x:25:18) ;
    y := x  * x   ;
    writeln ('x * x = ',y:25:18) ;
    q := intval (quad,quad) ;
    writeln (' q    = ',q:25:18) ;
    y := y - q ;
    writeln ('f (x) = ',y:25:18) ;
    f := y ;
$on
    f := x * x - quad ;
  end ;

function fs (x : cinterval) : cinterval ;
    var y : cinterval ;
  begin
$on
 {   writeln (' x =    ',x:25:18) ;  }
    y :=  2 * x ;
    writeln ('fs (x)= ',y:25:18) ;
    fs := y ;
$off
    fs :=  2 * x ;
$on
  end ;

function start (x : complex) : cinterval ;
  var inf, sup : complex ;
  begin
    if  re(x) >= 1  then
     begin
      sup.re := re(x) ;
      inf.re := (1.0)
     end
    else
    if  re(x) >= 0  then
     begin
      inf.re := re(x) ;
      sup.re := (1.0)
     end
    else
    if  re(x) > -1  then
     begin
      sup.re := re(x) ;
      inf.re := (-1.0)
     end
    else
    (*  re(x) <= -1  *)
     begin
      inf.re := re(x) ;
      sup.re := (-1.0)
     end ;

    if  im(x) >= 1  then
     begin
      sup.im := im(x) ;
      inf.im := (1.0)
     end
    else
    if  im(x) >= 0  then
     begin
      inf.im := im(x) ;
      sup.im := (1.0)
     end
    else
    if  im(x) > -1  then
     begin
      sup.im := im(x) ;
      inf.im := (-1.0)
     end
    else
    (*  im(x) <= -1  *)
     begin
      inf.im := im(x) ;
      sup.im := (-1.0)
     end ;

    start := intval (inf, sup) ;
  end ;  { function start }


  var m, z : cinterval ;
	{ intval for one argument not yet impl. because of debug option -r }
begin
 quad := 4.0 ;
 write ('quad = ') ;
 if eoln then get (input) ;
 read (quad) ;
 while  quad <> -1.10  do
  begin
    y := start (quad) ;
    { read (y) ; }
    writeln ('input = ',quad) ;
    writeln ('start = ',y) ;
    repeat
       x := y ;
       m := intval(mid(x)) ;
$on
       writeln ('Mitte:  ',m:25:18) ;
       y := f(m) ;
       writeln ('  f(m)  ',y:25:18) ;
       z := fs(x) ;
       writeln (' fs(x)  ',z:25:18) ;
       y := y / z  ;
       writeln ('nach /  ',y:25:18) ;
       y := m - y ;
       writeln ('nach -  ',y:25:18) ;
       y := y ** x ;
       writeln ('nach ** ',y:25:18) ;
$off
       y := (m - f(m) / fs (x)) ** x ;
$on
       if x.re.inf <> y.re.inf then
	 writeln ('x.re.inf=',x.re.inf:26, ' y.re.inf=',y.re.inf:26) ;
       if x.re.sup <> y.re.sup then
	 writeln ('x.re.sup=',x.re.sup:26, ' y.re.sup=',y.re.sup:26) ;
       if x.im.inf <> y.im.inf then
	 writeln ('x.im.inf=',x.im.inf:26, ' y.im.inf=',y.im.inf:26) ;
       if x.im.sup <> y.im.sup then
	 writeln ('x.im.sup=',x.im.sup:26, ' y.im.sup=',y.im.sup:26) ;

       writeln ('y=',y:22:18) ;
$on
    until  (x.re.inf = y.re.inf) and (x.re.sup = y.re.sup) and
	   (x.im.inf = y.im.inf) and (x.im.sup = y.im.sup) ;
    writeln ('result= ',x:25:18) ;
  {  if  not ( sqrt (quad)  in x)  then          }
  {    writeln ('Enthaelt nicht ', sqrt(quad)) ; }
    write ('quad = ') ;
    read (quad) ;
   end ; { until quad <= 1 }
end.
