MODULE awalangu;

GLOBAL CONST

{ Strings fuer Hauptprogramm AWA : }

   YES      =  'yes';
   NO       =  'no';

   EINL1_1  =  'enter out,T_start,T_end,h_initial and p ';
   EINL1_2  =  '                 out = ';
   EINL1_2a =  'WARNING: no results will be printed if out <= 0 !!';
   EINL1_3  =  '             T_start = ';
   EINL1_3a =  'WARNING: T_start is not exactly convertible to binary format !!';
   EINL1_4  =  '              T_end  = ';
   EINL1_4a =  'WARNING: T_end is not exactly convertible to binary format !!';
   EINL1_5  =  'initial stepsize  h  = ';
   EINL1_6  =  '        order     p  = ';
   EINL1_6a =  'WARNING: p must be >= 2 !!';

   EINL1_7  =  'enclosure method : ( 0 ) interval-vector';
   EINL1_8  =  '                   ( 1 ) parallel-epiped';
   EINL1_9  =  '                   ( 2 ) QR-decomposition';
   EINL1_10 =  '                   ( 3 ) intersection (0), (1)';
   EINL1_11 =  '                   ( 4 ) intersection (0), (2) ';

   EINL1_12 =  ' interval-Vector';
   EINL1_13 =  ' parallel-epiped';
   EINL1_14 =  ' parallel-epiped with QR-decomposition';
   EINL1_15 =  ' intersection of interval-vector and parallel-epiped';
   EINL1_16 =  ' intersection of interval-vector and QR-decomposition';

   EINL1_17 =  'output : ( 0 ) function values';
   EINL1_18 =  '         ( 1 ) Taylor coefficients    on grid';
   EINL1_19 =  '         ( 2 ) T.coeff. * powers of h  - " -';
   EINL1_20 =  '         ( 3 ) derivatives             - " -';
   EINL1_21 =  '         ( 4 ) Taylor coefficients   on subintervals';
   EINL1_22 =  '         ( 5 ) T.coeff. * powers of h  - " -';
   EINL1_23 =  '         ( 6 ) derivatives             - " -';
   EINL1_24 =  '         ( 7 ) output list      -> ?';
   EINL1_24a=  'WARNING: output options (1)..(6) not implemented in this version of AWA.';

   EINL1_25 =  'enclosure method : ';

   EINL1_26 =  'output : ';
   EINL1_27 =  ' function values';
   EINL1_28 =  ' Taylor coefficients on grid';
   EINL1_29 =  ' T.coeff. * powers of h on grid';
   EINL1_30 =  ' derivatives on grid';
   EINL1_31 =  ' Taylor coefficients on subintervals';
   EINL1_32 =  ' T.coeff. * powers of h on subintervals';
   EINL1_33 =  ' derivatives on subintervals';
   EINL1_34 =  ' output list';


   EINL2_1  =  'enter initial values : ';
   EINL2_2  =  'print overestimation (y/n) ->';


   MAIN_1   =  'new differential equation (y/n)';
   MAIN_2   =  'no enclosure after 10 iterations. ';
   MAIN_3   =  'continue iterating (y/n)';
   MAIN_4   =  'new step size h = ';
   MAIN_5   =  'continued iterating.';
   MAIN_6   =  ' matrix inversion not possible. ';
   MAIN_7   =  'end ';
   MAIN_8   =  '. integration block, continue (y/n)';
   MAIN_9   =  'new initial values (y/n)';
   MAIN_10  =  'Accuracy too bad: integration aborted !';
   MAIN_11  =  '                  Try again with different error tolerances and/or';
   MAIN_12  =  '                  larger order p and/or reduce size of initial value set.';


{  Strings fuer Paket EINGABE.PAK :  }


   NEXTA_1  =  'ERROR: invalid or misplaced character : ';
   NEXTA_2  =  'ERROR: no more character found in NEXTATOM !';


   WERT_0   =  'ERROR: unknown function/variable : ';
   WERT_01  =  'ERROR: not a function : ';
   WERT_1   =  'ERROR: no '')'' after EXPRESSION !';
   WERT_2   =  'ERROR: no ''('' in function call';
   WERT_3   =  'ERROR: wrong argument in sico(..)';
   WERT_4   =  'ERROR: no '')'' in function call';


   FAUF_1   =  '         Enclosing the Solutions of Ordinary Initial Value Problems.';
   FAUF_2   =  '                       Program by Rudolf Lohner';
   FAUF_3   =  '                   Institute for Applied Mathematics';
   FAUF_4   =  '                        University of Karlsruhe';
   FAUF_5   =  'dimension  n = ';
   FAUF_5a  =  'dimension of system must be > 0 !!';

   FAUF_6   =  'enter file name for input data or <cr> for interactive input';
   FAUF_7   =  '-> ?';
   FAUF_8   =  'enter differential equation :';

   FAUF_9   =  'enter output list :';
   FAUF_10  =  'ERROR: only variables allowed in output list !';

   FAUF_11  =  'enter filename for output data or <cr> -> ?';
   FAUF_12  =  'ode read from file ';
   FAUF_13  =  'ode read interactively';
   FAUF_14  =  ' ';

END.
